from manifest_edit.plugin.manifest_iterators import (
    ManifestIterator as BaseManifestIterator
)
from manifest_edit.plugin.manifest_iterators import FieldMatcher

from schema import Schema, Or, And, Optional
import re


class ManifestIterator(BaseManifestIterator):

    _field_matcher = FieldMatcher()

    _recurse_keys = ['periods', 'adaptationSets', 'representations']

    def _schema(self):

        return Schema(
            {
                # 'periods' is mandatory. After this, you either have the
                #   specific plugin configuration or (possibly multiple)
                #   couples of <key> : <regular expression> couples, followed
                #   by the 'adaptationSets' keyword.
                'periods': Or(self._plugin_config_schema, [
                    And({
                        str: lambda s: re.compile(s),
                        Optional('adaptationSets'): Or(self._plugin_config_schema, [
                            And({
                                str: lambda s: re.compile(s),
                                Optional('representations'): Or(
                                    self._plugin_config_schema,
                                    [And({str: lambda s: re.compile(s)},
                                         lambda x: len(x.keys()) > 1
                                         )
                                     ]
                                )
                            }, lambda x: len(x.keys()) > 1)
                        ])
                    }, lambda x: len(x.keys()) > 1
                    )
                ])
            }
        )
